package me.mrletsplay.advancedinfo.command;

import me.mrletsplay.advancedinfo.AdvancedInfoMod;
import me.mrletsplay.mrcore.command.event.CommandInvokedEvent;
import me.mrletsplay.mrcore.fabric.command.FabricCommand;
import net.minecraft.block.Block;
import net.minecraft.entity.Entity;
import net.minecraft.entity.ai.brain.MemoryModuleType;
import net.minecraft.entity.passive.VillagerEntity;
import net.minecraft.item.ItemStack;
import net.minecraft.registry.RegistryKey;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.server.world.ServerWorld;
import net.minecraft.util.Language;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.GlobalPos;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.World;

public class VillagerInfoCommand extends FabricCommand {

	public VillagerInfoCommand() {
		super("villagerinfo");
	}

	@Override
	public void action(CommandInvokedEvent event) {
		ServerPlayerEntity p = getSenderPlayer(event);
		if(p == null) {
			event.getSender().sendMessage("Player only");
			return;
		}

		ServerWorld world = p.getServerWorld();
		Vec3d dir = p.getRotationVector();
		Entity entity = AdvancedInfoMod.raycastEntity(world, p.getEyePos(), p.getEyePos().add(dir.multiply(4)));
		if(entity == null || !(entity instanceof VillagerEntity)) {
			event.getSender().sendMessage("§cYou are not looking at a villager");
			return;
		}

		VillagerEntity villager = (VillagerEntity) entity;
		event.getSender().sendMessage("§aYou are looking at a §7" + villager.getVariant() + " " + villager.getVillagerData().getProfession().id());
		event.getSender().sendMessage("§aInventory:");
		for(ItemStack it : villager.getInventory().heldStacks) {
			event.getSender().sendMessage("§a- §7" + it.getCount() + "§ax §7" + Language.getInstance().get(it.getItem().getTranslationKey()));
		}

		GlobalPos jobSite = villager.getBrain().getOptionalMemory(MemoryModuleType.JOB_SITE).orElse(null);
		if(jobSite == null) {
			event.getSender().sendMessage("§aJob site: §7None");
		}else {
			RegistryKey<World> dim = jobSite.dimension();
			BlockPos pos = jobSite.pos();
			String posStr = String.format("(%s, %s, %s)", pos.getX(), pos.getY(), pos.getZ());
			Block block = p.getServer().getWorld(dim).getBlockState(pos).getBlock();
			event.getSender().sendMessage(String.format("§aJob site: §7%s §ain §7%s at %s",
				Language.getInstance().get(block.getTranslationKey()),
				dim.getValue().getPath(),
				posStr));
		}

		GlobalPos bed = villager.getBrain().getOptionalMemory(MemoryModuleType.HOME).orElse(null);
		if(bed == null) {
			event.getSender().sendMessage("§aBed: §7None");
		}else {
			RegistryKey<World> dim = bed.dimension();
			BlockPos pos = bed.pos();
			String posStr = String.format("(%s, %s, %s)", pos.getX(), pos.getY(), pos.getZ());
			Block block = p.getServer().getWorld(dim).getBlockState(pos).getBlock();
			event.getSender().sendMessage(String.format("§aBed: §7%s §ain §7%s at %s",
				Language.getInstance().get(block.getTranslationKey()),
				dim.getValue().getPath(),
				posStr));
		}
	}

}
